## org.opengis.geometry.primitive
Interface Curve

All Superinterfaces:
  GenericCurve, Geometry, OrientableCurve, OrientablePrimitive, Primitive, TransfiniteSet

    @UML(identifier="GM_Curve",
         specification=ISO_19107)
    public interface Curve

extends OrientableCurve, GenericCurve

Curve with a positive orientation. `Curve` is a descendent subtype of `Primitive` through `OrientablePrimitive`. It is the basis for 1-dimensional geometry. A curve is a continuous image of an open interval and so could be written as a parameterized function such as `c(t):(a, b) → En` where "t" is a real parameter and En is Euclidean space of dimension n (usually 2 or 3, as determined by the coordinate reference system). Any other parameterization that results in the same image curve, traced in the same direction, such as any linear shifts and positive scales such as `e(t) = c(a + t(b-a)):(0,1) → En`, is an equivalent representation of the same curve. For the sake of simplicity, `Curve`s should be parameterized by arc length, so that the parameterization operation inherited from `GenericCurve` will be valid for parameters between 0 and the length of the curve.

Curves are continuous, connected, and have a measurable length in terms of the coordinate system. The orientation of the curve is determined by this parameterization, and is consistent with the tangent function, which approximates the derivative function of the parameterization and shall always point in the "forward" direction. The parameterization of the reversal of the curve defined by `c(t):(a, b) → En` would be defined by a function of the form `s(t) = c(a + b - t):(a, b) → En`.

A curve is composed of one or more curve segments. Each curve segment within a curve may be defined using a different interpolation method. The curve segments are connected to one another, with the end point of each segment except the last being the start point of the next segment in the segment list.

Since:
  GeoAPI 1.0
Version:
  ISO 19107
See Also:
  `PrimitiveFactory.createCurve(java.util.List<org.opengis.geometry.primitive.CurveSegment>)`

Method Summary
`List<? extends CurveSegment>` `getSegments()` Lists the components curve segments of `Curve`, each of which defines the direct position of points along a portion of the curve.

Methods inherited from interface OrientablePrimitive
`getOrientation, getPrimitive`

Methods inherited from interface Primitive
`getComplexes, getComposite, getContainedPrimitives, getContainingPrimitives, getProxy`

Methods inherited from interface Geometry
`clone, distance, getBoundary, getBuffer, getCentroid, getClosure, getConvexHull, getCoordinateDimension, getCoordinateReferenceSystem, getDimension, getDistance, getEnvelope, getMaximalComplex, getMbRegion, getPrecision, getRepresentativePoint, isCycle, isMutable, isSimple, toImmutable, transform, transform`

Methods inherited from interface TransfiniteSet
`contains, contains, difference, equals, intersection, intersects, symmetricDifference, union`

Methods inherited from interface GenericCurve
`asLineString, forConstructiveParam, forParam, getEndConstructiveParam, getEndParam, getEndPoint, getParamForPoint, getStartConstructiveParam, getStartParam, getStartPoint, getTangent, length, length`

Method Detail

### getSegments

    @Association(value="Segmentation")
    @UML(identifier="segment",
         obligation=MANDATORY,
         specification=ISO_19107)
    List<? extends CurveSegment> getSegments()

  Lists the components curve segments of `Curve`, each of which defines the direct position of points along a portion of the curve. The order of the curve segments is the order in which they are used to trace this `Curve`. For a particular parameter interval, the `Curve` and `CurveSegment` agree.

  Returns:
    The list of curve segments. Should never be `null` neither empty.
  See Also:
    `CurveSegment.getCurve()`, `Surface.getPatches()`

Copyright © 1994-2008 Open Geospatial Consortium. All Rights Reserved.